/*************************************************************************/
/*  Job Server  UNIX Version                                             */
/*                                                                       */
/*  Zeno Job Server                                                      */
/*  Copyright (C) 2005  Scott Auge, Amduus Information Works, Inc.       */
/*                                                                       */
/*  This program is free software; you can redistribute it and/or modify */
/*  it under the terms of the GNU General Public License as published by */
/*  the Free Software Foundation; either version 2 of the License, or    */
/*  (at your option) any later version.                                  */
/*                                                                       */
/*  This program is distributed in the hope that it will be useful,      */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of       */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        */
/*  GNU General Public License for more details.                         */
/*                                                                       */
/*  You should have received a copy of the GNU General Public License    */
/*  along with this program; if not, write to                            */
/*                                                                       */
/*  Free Software Foundation, Inc.                                       */
/*  59 Temple Place, Suite 330                                           */
/*  Boston, MA  02111-1307  USA                                          */
/*                                                                       */
/*************************************************************************/ 

FUNCTION MakeID3 RETURNS CHARACTER (INPUT pLength AS INTEGER) FORWARD.

DEFINE INPUT PARAMETER iLength AS INTEGER NO-UNDO.
DEFINE OUTPUT PARAMETER cID AS CHARACTER NO-UNDO.

ASSIGN cID = MakeID3 (iLength).

/*************************************************************************/
/* This is a function that actually generates the goods.  It was in an   */
/* include file, but is used so often we might as well save r-code space */
/* and put it into it's own procedure.                                   */
/*************************************************************************/

FUNCTION MakeID3 RETURNS CHARACTER (INPUT pLength AS INTEGER):

  DEF VAR i AS CHARACTER NO-UNDO.

  RUN RandomString (INPUT pLength, OUTPUT i).

  ASSIGN i = i + STRING(ETIME).

  RETURN i.

END. /* FUNCTION MakeID3() */

/*************************************************************************/
/* Define the alphabet we make the ID out of, as well as play swap a roo */
/* with the alphabet to generate an ID.                                  */
/*                                                                       */
/*        ##   ##   ##    ######  ##   ##  ####   ##   ##   ####         */
/*       ##   ##  ####    ##  ## ###  ##   ##    ###  ##  ##  ##         */
/*      ##   ## ##  ##   ##  ## #### ##   ##    #### ## ##               */
/*     ## # ## ##  ##   #####  ## ####   ##    ## #### ##                */
/*    ####### ######   ## ##  ##  ###   ##    ##  ### ##  ###            */
/*   ### ### ##  ##   ##  ## ##   ##   ##    ##   ##  ##  ##             */
/*  ##   ## ##  ##  ###  ## ##   ##  ####   ##   ##   #####              */
/*                                                                       */
/* This routine REQUIRES -rand 2 in order to work properly!              */
/*************************************************************************/
                                                   
PROCEDURE RandomString:

  DEF INPUT PARAMETER pLength   AS INTEGER NO-UNDO.
  DEF OUTPUT PARAMETER pString  AS CHARACTER NO-UNDO.

  DEF VAR lAlphabet AS CHARACTER NO-UNDO.
  DEF VAR i         AS INTEGER NO-UNDO.

  ASSIGN 
  lAlphabet = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789"
  i = 0
  pString = "".

  DO WHILE i < pLength:

    ASSIGN 
    i = i + 1
    pString = pString + SUBSTRING(lAlphabet, RANDOM(1,LENGTH(lAlphabet)), 1).

  END. /* DO WHILE i < pLength */

END. /* PROCEDURE RandomString */
